import React from 'react';
import type { BadgeVariant, IconGlyph, SignalPopover } from '@mongodb-js/compass-components';
import type { ItemType } from './use-create';
import type { ViewType } from './use-view-type';
export type BadgeProp = {
    id: string;
    name: string;
    variant?: BadgeVariant;
    icon?: IconGlyph;
    hint?: React.ReactNode;
};
export type DataProp = {
    label: React.ReactNode;
    value: React.ReactNode;
    hint?: React.ReactNode;
    insights?: React.ComponentProps<typeof SignalPopover>['signals'];
};
export type NamespaceItemCardProps = {
    id: string;
    type: ItemType;
    viewType: ViewType;
    name: string;
    status: 'initial' | 'fetching' | 'refreshing' | 'ready' | 'error';
    data: DataProp[];
    badges?: BadgeProp[] | null;
    onItemClick(id: string): void;
    onItemDeleteClick?: (id: string) => void;
};
export declare const NamespaceItemCard: React.FunctionComponent<NamespaceItemCardProps & Omit<React.HTMLProps<HTMLDivElement>, Extract<keyof NamespaceItemCardProps, string>>>;
//# sourceMappingURL=namespace-card.d.ts.map