"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NamespaceItemCard = void 0;
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const namespace_param_1 = require("./namespace-param");
const provider_1 = require("compass-preferences-model/provider");
const cardTitleGroup = (0, compass_components_1.css)({
    display: 'flex',
    alignItems: 'center',
    gap: compass_components_1.spacing[3],
    marginBottom: compass_components_1.spacing[2],
});
const CardTitleGroup = ({ children }) => {
    return react_1.default.createElement("div", { className: cardTitleGroup }, children);
};
const cardNameWrapper = (0, compass_components_1.css)({
    minWidth: 0,
});
const cardNameDark = (0, compass_components_1.css)({
    color: compass_components_1.palette.green.light2,
});
const cardNameLight = (0, compass_components_1.css)({
    color: compass_components_1.palette.green.dark2,
});
const cardName = (0, compass_components_1.css)({
    overflow: 'hidden',
    whiteSpace: 'nowrap',
    textOverflow: 'ellipsis',
    paddingTop: 2,
    paddingBottom: 2,
    fontWeight: '600 !important',
});
const CardName = ({ children, }) => {
    const darkMode = (0, compass_components_1.useDarkMode)();
    return (react_1.default.createElement("div", { title: children, className: cardNameWrapper },
        react_1.default.createElement(compass_components_1.Subtitle, { as: "div", className: (0, compass_components_1.cx)(cardName, darkMode ? cardNameDark : cardNameLight) }, children)));
};
const cardActionContainer = (0, compass_components_1.css)({
    marginLeft: 'auto',
    flex: 'none',
});
const cardBadges = (0, compass_components_1.css)({
    display: 'flex',
    gap: compass_components_1.spacing[2],
    minHeight: 20,
});
const CardBadges = ({ children }) => {
    return react_1.default.createElement("div", { className: cardBadges }, children);
};
const cardBadge = (0, compass_components_1.css)({
    gap: compass_components_1.spacing[1],
});
const cardBadgeLabel = (0, compass_components_1.css)({});
const CardBadge = ({ id, name, icon, variant, hint, }) => {
    const badge = (0, react_1.useCallback)(({ className, children, ...props } = {}) => {
        return (react_1.default.createElement(compass_components_1.Badge, { "data-testid": `collection-badge-${id}`, className: (0, compass_components_1.cx)(cardBadge, className), variant: variant, ...props },
            icon && react_1.default.createElement(compass_components_1.Icon, { size: "small", glyph: icon }),
            react_1.default.createElement("span", { className: cardBadgeLabel }, name),
            children));
    }, [id, icon, name, variant]);
    if (hint) {
        return (react_1.default.createElement(compass_components_1.Tooltip, { delay: 500, trigger: badge }, hint));
    }
    return badge();
};
const card = (0, compass_components_1.css)({
    padding: compass_components_1.spacing[3],
});
const namespaceDataGroup = (0, compass_components_1.css)({
    display: 'flex',
    gap: compass_components_1.spacing[2],
    marginTop: compass_components_1.spacing[3],
});
const column = (0, compass_components_1.css)({
    flexDirection: 'column',
});
const NamespaceItemCard = ({ id, type, name, status, data, onItemClick, onItemDeleteClick, badges = null, viewType, ...props }) => {
    const readOnly = (0, provider_1.usePreference)('readOnly');
    const [hoverProps, isHovered] = (0, compass_components_1.useHoverState)();
    const [focusProps, focusState] = (0, compass_components_1.useFocusState)();
    const onDefaultAction = (0, react_1.useCallback)(() => {
        onItemClick(id);
    }, [onItemClick, id]);
    const hasDeleteHandler = !!onItemDeleteClick;
    const cardActions = (0, react_1.useMemo)(() => {
        return readOnly || !hasDeleteHandler
            ? []
            : [
                {
                    action: 'delete',
                    label: `Delete ${type}`,
                    icon: 'Trash',
                },
            ];
    }, [type, readOnly, hasDeleteHandler]);
    const defaultActionProps = (0, compass_components_1.useDefaultAction)(onDefaultAction);
    const onAction = (0, react_1.useCallback)((action) => {
        if (action === 'delete') {
            onItemDeleteClick?.(id);
        }
    }, [onItemDeleteClick, id]);
    const badgesGroup = badges && (react_1.default.createElement(CardBadges, null, badges.map((badge) => {
        return react_1.default.createElement(CardBadge, { key: badge.id, ...badge });
    })));
    const cardProps = (0, compass_components_1.mergeProps)({ className: card }, defaultActionProps, hoverProps, focusProps, props);
    const isButtonVisible = [compass_components_1.FocusState.FocusVisible, compass_components_1.FocusState.FocusWithinVisible].includes(focusState) || isHovered;
    return (react_1.default.createElement(compass_components_1.Card, { key: id, contentStyle: "clickable", "data-testid": `${type}-grid-item`, "data-id": id, ...cardProps },
        react_1.default.createElement(CardTitleGroup, null,
            react_1.default.createElement(CardName, null, name),
            viewType === 'list' && badgesGroup,
            react_1.default.createElement(compass_components_1.ItemActionControls, { "data-testid": "namespace-card-actions", isVisible: isButtonVisible && cardActions.length > 0, actions: cardActions, onAction: onAction, className: cardActionContainer })),
        viewType === 'grid' && badgesGroup,
        react_1.default.createElement("div", { className: (0, compass_components_1.cx)(namespaceDataGroup, viewType === 'grid' && column) }, data.map(({ label, value, hint, insights }, idx) => {
            return (react_1.default.createElement(namespace_param_1.NamespaceParam, { key: idx, label: label, hint: hint, value: value, status: status, viewType: viewType, insights: insights }));
        }))));
};
exports.NamespaceItemCard = NamespaceItemCard;
//# sourceMappingURL=namespace-card.js.map