"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NamespaceParam = void 0;
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const provider_1 = require("compass-preferences-model/provider");
const namespaceParam = (0, compass_components_1.css)({
    display: 'flex',
    gap: '1ch',
    flex: 1,
    overflow: 'hidden',
    whiteSpace: 'nowrap',
    textOverflow: 'ellipsis',
    minWidth: 0,
    maxWidth: compass_components_1.spacing[6] * 4,
});
const multiline = (0, compass_components_1.css)({
    display: 'flex',
    flexDirection: 'column',
    gap: 0,
});
const namespaceParamLabel = (0, compass_components_1.css)({
    fontWeight: 'bold',
});
const namespaceParamValueContainer = (0, compass_components_1.css)({
    position: 'relative',
    width: '100%',
    minHeight: 20,
});
const namespaceParamValueContainerWithInsights = (0, compass_components_1.css)({
    display: 'flex',
    alignItems: 'center',
    gap: compass_components_1.spacing[2],
});
const namespaceParamValue = (0, compass_components_1.css)({
    opacity: 1,
    transition: 'opacity .16s linear',
});
const namespaceParamValueRefreshing = (0, compass_components_1.css)({
    opacity: 0.3,
});
const namespaceParamValueMissing = (0, compass_components_1.css)({
    opacity: 0.3,
});
const namespaceParamValuePlaceholder = (0, compass_components_1.css)({
    position: 'absolute',
    top: 0,
    left: 0,
    bottom: 0,
    right: 0,
    display: 'flex',
    opacity: 0,
    transition: 'opacity .16s ease-out',
});
const visible = (0, compass_components_1.css)({
    opacity: 1,
    transitionTimingFunction: 'ease-in',
});
const fadeInAnimation = (0, compass_components_1.keyframes)({
    from: {
        opacity: 0,
    },
    to: {
        opacity: 1,
    },
});
const fadeIn = (0, compass_components_1.css)({
    animation: `${fadeInAnimation} .16s ease-out`,
});
const NamespaceParam = ({ label, value, status, hint, viewType, insights }) => {
    const showInsights = (0, provider_1.usePreference)('showInsights');
    const renderedValue = (0, react_1.useMemo)(() => {
        const isReady = status !== 'initial' && status !== 'fetching';
        return (react_1.default.createElement(compass_components_1.ContentWithFallback, { isContentReady: isReady, content: (shouldRender, shouldAnimate) => {
                if (!shouldRender) {
                    return null;
                }
                const missingValue = value == null || status === 'error';
                return (react_1.default.createElement("span", { className: (0, compass_components_1.cx)(namespaceParamValue, missingValue && namespaceParamValueMissing, status === 'refreshing' && namespaceParamValueRefreshing, shouldAnimate && fadeIn) }, missingValue ? '—' : value));
            }, fallback: (shouldRender) => (react_1.default.createElement("span", { "data-testid": "namespace-param-fallback", "data-ready": isReady, className: (0, compass_components_1.cx)(namespaceParamValuePlaceholder, shouldRender && visible) },
                react_1.default.createElement(compass_components_1.Placeholder, { maxChar: 10 }))) }));
    }, [value, status]);
    return (react_1.default.createElement("div", { className: (0, compass_components_1.cx)(namespaceParam, viewType === 'list' && multiline) },
        react_1.default.createElement("span", { className: namespaceParamLabel }, hint ? (react_1.default.createElement(compass_components_1.InlineDefinition, { tooltipProps: {
                align: 'top',
                justify: 'start',
                delay: 500,
            }, definition: hint },
            label,
            ":")) : (react_1.default.createElement(react_1.default.Fragment, null,
            label,
            ":"))),
        react_1.default.createElement("span", { className: (0, compass_components_1.cx)(namespaceParamValueContainer, insights && namespaceParamValueContainerWithInsights) },
            renderedValue,
            showInsights && insights && (react_1.default.createElement(compass_components_1.SignalPopover, { signals: insights })))));
};
exports.NamespaceParam = NamespaceParam;
//# sourceMappingURL=namespace-param.js.map