"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useViewTypeControls = void 0;
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
const VIEW_TYPE_SETTINGS_KEY = 'compass_items_grid_view_type';
function getViewTypeSettingsFromSessionStorage(defaultType = 'grid') {
    try {
        return (window.sessionStorage.getItem(VIEW_TYPE_SETTINGS_KEY) ??
            defaultType);
    }
    catch {
        return defaultType;
    }
}
function setViewTypeSettingsFromSessionStorage(val) {
    try {
        window.sessionStorage.setItem(VIEW_TYPE_SETTINGS_KEY, val);
    }
    catch {
    }
}
const controlsContainer = (0, compass_components_1.css)({
    display: 'flex',
    alignItems: 'center',
    gap: compass_components_1.spacing[2],
});
const label = (0, compass_components_1.css)({
    margin: '0 !important',
    padding: '0 !important',
});
function useViewTypeControls({ defaultViewType = 'list', onChange = () => {
}, }) {
    const [viewType, setViewType] = (0, react_1.useState)(() => getViewTypeSettingsFromSessionStorage(defaultViewType));
    (0, react_1.useEffect)(() => {
        setViewTypeSettingsFromSessionStorage(viewType);
    }, [viewType]);
    const onViewTypeChange = (0, react_1.useCallback)((val) => {
        onChange(val);
        setViewType(val);
    }, [onChange]);
    const labelId = (0, compass_components_1.useId)();
    const controlId = (0, compass_components_1.useId)();
    const viewControls = (0, react_1.useMemo)(() => {
        return (react_1.default.createElement("div", { className: controlsContainer },
            react_1.default.createElement(compass_components_1.Label, { id: labelId, htmlFor: controlId, className: label }, "View"),
            react_1.default.createElement(compass_components_1.SegmentedControl, { id: controlId, "aria-labelledby": labelId, value: viewType, onChange: onViewTypeChange },
                react_1.default.createElement(compass_components_1.SegmentedControlOption, { value: "list", glyph: react_1.default.createElement(compass_components_1.Icon, { glyph: "Menu" }) }),
                react_1.default.createElement(compass_components_1.SegmentedControlOption, { value: "grid", glyph: react_1.default.createElement(compass_components_1.Icon, { glyph: "Apps" }) }))));
    }, [labelId, controlId, viewType, onViewTypeChange]);
    return [viewControls, viewType];
}
exports.useViewTypeControls = useViewTypeControls;
//# sourceMappingURL=use-view-type.js.map